package com.rthoni.camotion.ui.dialogs;

import android.app.ProgressDialog;
import android.content.Context;

import com.luticate.auth.business.LuticateUsersBusiness;
import com.luticate.auth.dbo.LuLoginDbo;
import com.luticate.utils.business.LuPromise;
import com.luticate.utils.dataaccess.LuDataAccess;
import com.luticate.utils.dbo.LuDataAccessConfigDbo;
import com.rthoni.camotion.R;
import com.rthoni.camotion.dbo.LocationDbo;

/**
 *
 * Created by robin on 11/28/15.
 */
public class LoginDialog extends ProgressDialog {
    public LoginDialog(Context context) {
        super(context);
        setTitle(R.string.loading);
        setIndeterminate(true);
        setMessage(context.getString(R.string.login_progress));
    }

    public LuPromise<LuLoginDbo> login(LocationDbo location)
    {
        final LuPromise<LuLoginDbo> promise = new LuPromise<>();
        show();
        LuDataAccessConfigDbo config = new LuDataAccessConfigDbo();
        config.setBaseUrl(location.getBaseUrl());
        LuticateUsersBusiness.login(config, location.getUsername(), location.getPassword())
                .then(new LuPromise.LuConsumer<LuLoginDbo>() {
                    @Override
                    public void execute(LuLoginDbo data) {
                        hide();
                        promise.resolve(data);
                    }
                }, new LuPromise.LuConsumer<LuPromise.LuPromiseError>() {
                    @Override
                    public void execute(LuPromise.LuPromiseError data) {
                        hide();
                        promise.reject(data);
                    }
                });
        return promise;
    }
}
